﻿import es
import keyvalues
import langlib
import os
import playerlib
import popuplib

addon = es.import_addon("soccer_mod_2011/admin/settings")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "admin/settings/messages_settings_skins.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings_skins.ini")

settings = ["t", "ct", "t_gk", "ct_gk"]

# ******************** Load ********************
def load():
	for item in settings:
		es.set("sm_skins_default_%s" % (item), es.keygetvalue("soccer_mod_settings", "skins", "default_%s" % (item)))

	create_popup()

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_settings_skins")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(settings)):
		value = str(es.ServerVar("sm_skins_default_%s" % (settings[i])))
		popup.addline("->%s. %s: %s" % (i + 1, popup_text(settings[i]), value[14:len(value)]))
		popup.select(i + 1, popup_choice)

	popup.addline("->5. Set personal terrorist skin")
	popup.addline("->6. Set personal counter-terrorist skin")
	popup.addline("->7. Remove personal skin")
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(5, 8):
		popup.select(i, popup_choice)

	popup.submenu(8, "sm_popup_admin_settings_skins")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	if choice < 5:
		open_path(userid, str("cstrike/models/player"), choice)

	elif choice < 7:
		myPopup = popuplib.easymenu(popup_name, None, select_player)

		myPopup.settitle("Select a player")

		for ply in playerlib.getPlayerList("#human"):
			myPopup.addoption("%s_%s" % (choice, ply.userid), ply.name)

		myPopup.submenu(10, "sm_popup_admin_settings_skins")

		popuplib.send(popup_name, userid)

	else:
		myPopup = popuplib.easymenu(popup_name, None, remove)

		myPopup.settitle("Remove personal skin")

		skins = keyvalues.getKeyGroup("soccer_mod_skins")
		for item in skins:
			myPopup.addoption(item, es.keygetvalue("soccer_mod_skins", item, "name"))

		myPopup.submenu(10, "sm_popup_admin_settings_skins")

		popuplib.send(popup_name, userid)

# ******************** Easymenu choice ********************
def select_skin(userid, choice, keymenuname):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	length = len(choice)

	type = choice.split("_")
	if type[0] == "dir":
		open_path(userid, str(choice[6:length]), type[1])
	else:
		player = playerlib.getPlayer(userid)
		value = choice[15:length]

		tokens = {}
		tokens["name"] = player.name
		tokens["value"] = value[14:len(value)]

		if int(type[1]) == 1:
			es.set("sm_skins_default_t", value)
			es.keysetvalue("soccer_mod_settings", "skins", "default_t", value)

			line = "->1. %s: %s" % (popup_text("t"), tokens["value"])
			popuplib.find("sm_popup_admin_settings_skins").modline(3, line)

			lang_msg("set_t", tokens)

		elif int(type[1]) == 2:
			es.set("sm_skins_default_ct", value)
			es.keysetvalue("soccer_mod_settings", "skins", "default_ct", value)

			line = "->2. %s: %s" % (popup_text("ct"), tokens["value"])
			popuplib.find("sm_popup_admin_settings_skins").modline(4, line)

			lang_msg("set_ct", tokens)

		elif int(type[1]) == 3:
			es.set("sm_skins_default_t_gk", value)
			es.keysetvalue("soccer_mod_settings", "skins", "default_t_gk", value)

			line = "->3. %s: %s" % (popup_text("t_gk"), tokens["value"])
			popuplib.find("sm_popup_admin_settings_skins").modline(5, line)

			lang_msg("set_t_gk", tokens)

		elif int(type[1]) == 4:
			es.set("sm_skins_default_ct_gk", value)
			es.keysetvalue("soccer_mod_settings", "skins", "default_ct_gk", value)

			line = "->4. %s: %s" % (popup_text("ct_gk"), tokens["value"])
			popuplib.find("sm_popup_admin_settings_skins").modline(6, line)

			lang_msg("set_ct_gk", tokens)

		elif int(type[1]) == 5:
			if es.exists("keygroup", "soccer_mod_skins") == 0:
				es.keygroupcreate("soccer_mod_skins")

			steamid = es.keygetvalue("sm_keygroup_set", player.steamid, "steamid")
			name = es.keygetvalue("sm_keygroup_set", player.steamid, "name")

			if es.exists("key", "soccer_mod_skins", steamid) == 0:
				es.keycreate("soccer_mod_skins", steamid)

			es.keysetvalue("soccer_mod_skins", steamid, "name", name)
			es.keysetvalue("soccer_mod_skins", steamid, "t", value)

			es.server.cmd("keygroupsort soccer_mod_skins name asc #alpha")
			es.keygroupsave("soccer_mod_skins", "soccer_mod")

			es.keydelete("sm_keygroup_set", player.steamid)

			es.tell(userid, "#green", "%s now has %s as personal terrorist skin." % (name, tokens["value"]))

		elif int(type[1]) == 6:
			if es.exists("keygroup", "soccer_mod_skins") == 0:
				es.keygroupcreate("soccer_mod_skins")

			steamid = es.keygetvalue("sm_keygroup_set", player.steamid, "steamid")
			name = es.keygetvalue("sm_keygroup_set", player.steamid, "name")

			if es.exists("key", "soccer_mod_skins", steamid) == 0:
				es.keycreate("soccer_mod_skins", steamid)

			es.keysetvalue("soccer_mod_skins", steamid, "name", name)
			es.keysetvalue("soccer_mod_skins", steamid, "ct", value)

			es.server.cmd("keygroupsort soccer_mod_skins name asc #alpha")
			es.keygroupsave("soccer_mod_skins", "soccer_mod")

			es.keydelete("sm_keygroup_set", player.steamid)

			es.tell(userid, "#green", "%s now has %s as personal counter-terrorist skin." % (name, tokens["value"]))

		es.keygroupsave("soccer_mod_settings", "soccer_mod")

		popuplib.send("sm_popup_admin_settings_skins", userid)

def select_player(userid, choice, popupname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	type = choice.split("_")
	if es.exists("userid", type[1]) == 1:
		target = playerlib.getPlayer(type[1])

		if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
			es.keycreate("sm_keygroup_set", player.steamid)

		es.keysetvalue("sm_keygroup_set", player.steamid, "name", target.name)
		es.keysetvalue("sm_keygroup_set", player.steamid, "steamid", target.steamid)

		open_path(userid, str("cstrike/models/player"), type[0])
	else:
		es.tell(userid, "#green", messages_common("no_player_found", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_settings_skins", userid)

def remove(userid, choice, keymenuname):
	if es.exists("key", "soccer_mod_skins", choice) == 1:
		es.keydelete("soccer_mod_skins", choice)
		es.keygroupsave("soccer_mod_skins", "soccer_mod")

		es.tell(userid, "#green", "Personal skin removed.")
	else:
		es.tell(userid, "#green", "Personal skin not found.")

	popuplib.send("sm_popup_admin_settings_skins", userid)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages_text(text, tokens, player.get("lang")))

def open_path(userid, path, choice):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	myPopup = popuplib.easymenu(popup_name, None, select_skin)
	myPopup.settitle(popup_text("select"))

	dirup = path.split("/")

	length = len(dirup) - 1
	dir = ""
	for i in range(0, length):
		if i < (length - 1):
			dir += dirup[i] + "/"
		else:
			dir += dirup[i]

	if path != "cstrike/models/player":
		myPopup.addoption("dir_%s_%s" % (choice, dir), "^ %s ^" % (popup_text("up")))

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == True:
			myPopup.addoption("dir_%s_%s/%s" % (choice, path, item), "(%s) %s" % (popup_text("folder"), item))

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == False:
			type = item.split(".")
			length = len(type) - 1
			if type[length] == "mdl":
				myPopup.addoption("file_%s_%s/%s" % (choice, path, item), item)

	myPopup.submenu(10, "sm_popup_admin_settings_skins")

	popuplib.send(popup_name, userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_skins")