﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages = langlib.Strings(lang_dir + "info/messages_info.ini")
messages_common = langlib.Strings(lang_dir + "messages_common.ini")

modules = ["commands", "help", "server", "leagues", "version", "credits"]

# ******************** Load ********************
def load():
	create_popup()

	for item in modules:
		es.load("soccer_mod_2011/info/%s" % (item))

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")
	text = langlib.Strings(lang_dir + "info/popup_info.ini")

	popup = popuplib.create("sm_popup_info")

	popup.addline("SOCCER MOD %s" % (text("title")))
	popup.addline(" ")

	for i in range(0, len(modules) - 1):
		popup.addline("->%s. %s" % (i + 1, text(modules[i])))
		popup.submenu(i + 1, "sm_popup_info_%s" % (modules[i]))

	popup.addline(" ")
	popup.addline("->9. %s" % (text("credits")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_info")

	popup.submenu(9, "sm_popup_info_credits")

# ******************** Events ********************
def player_activate(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		tokens = {}
		tokens["mod"] = "SOCCER MOD 2010 %s" % (es.ServerVar("soccer_mod_2011_version"))
		tokens["command"] = es.ServerVar("sm_command_info")

		player = playerlib.getPlayer(event_var["userid"])

		es.menu(10, int(event_var["userid"]), "%s\n \n%s" % (messages("uses", tokens, player.get("lang")), messages("info", tokens, player.get("lang"))))

# ******************** Commands ********************
def cmd_info():
	userid = es.getcmduserid()

	if es.ServerVar("soccer_mod_allowed") == 1:
		popuplib.send("sm_popup_info", userid)
	else:
		tokens = {}
		player = playerlib.getPlayer(userid)
		es.tell(userid, "#green", messages_common("not_allowed", tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info")

	for item in modules:
		es.unload("soccer_mod_2011/info/%s" % (item))