﻿import es
import langlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

text = langlib.Strings(lang_dir + "info/popup_info_server.ini")

# ******************** Load ********************
def load():
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	popuplib.delete("sm_popup_info_server")
	create_popup()

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")

	popup = popuplib.create("sm_popup_info_server")

	popup.addline(text("title"))
	popup.addline(" ")
	popup.addline("%s: %s" % (text("name"), es.ServerVar("hostname")))
	popup.addline("%s: %s:%s" % (text("ip"), es.ServerVar("ip"), es.ServerVar("hostport")))
	popup.addline("%s: %s" % (text("slots"), es.getmaxplayercount()))

	if int(es.ServerVar("tv_enable")) == 1:
		popup.addline(" ")
		popup.addline("%s: %s" % (text("tv_name"), es.ServerVar("tv_name")))
		popup.addline("%s: %s:%s" % (text("tv_ip"), es.ServerVar("ip"), es.ServerVar("tv_port")))
		popup.addline("%s: %s" % (text("tv_slots"), es.ServerVar("tv_maxclients")))

	popup.addline(" ")
	popup.addline("->1. %s" % (text("display")))
	popup.addline("->2. Soccer Mod 2010 %s" % (text("servers")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (common("close")))

	popup.select(1, server_info_to_chat)
	popup.select(2, view_website)

	for i in range(3, 9):
		popup.submenu(i, "sm_popup_info_server")

	popup.submenu(9, "sm_popup_info")

# ******************** Popup choice ********************
def server_info_to_chat(userid, choice, popupname):
	es.tell(userid, "#green", "%s: %s" % (text("name"), es.ServerVar("hostname")))
	es.tell(userid, "#green", "%s: %s:%s" % (text("ip"), es.ServerVar("ip"), es.ServerVar("hostport")))

	if int(es.ServerVar("tv_enable")) == 1:
		es.tell(userid, "#green", "%s: %s" % (text("tv_name"), es.ServerVar("tv_name")))
		es.tell(userid, "#green", "%s: %s:%s" % (text("tv_name"), es.ServerVar("ip"), es.ServerVar("tv_port")))

	popuplib.send(popupname, userid)

def view_website(userid, choice, popupname):
	es.server.queuecmd('usermsg motd %s 2 "Soccer Mod 2010 %s" "http://www.game-monitor.com/search.php?search=soccer_mod_2011_version&type=variable&public=&order=-var"' % (userid, text("servers")))

	popuplib.send(popupname, userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info_server")