﻿import es
import gamethread
import langlib
import math
import playerlib
import popuplib
import random

messages = langlib.Strings("cstrike/addons/eventscripts/soccer_mod_2011/language/modules/match/messages_match.ini")

afk = {}

# ******************** Events ********************
def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("sm_match_started") == 1:
			if es.ServerVar("period_break_running") == 1 or int(es.ServerVar("match_paused")) == 1:
				player = playerlib.getPlayer(event_var["userid"])
				player.freeze(1)

def round_start(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.ServerVar("match_paused") == 1 or es.ServerVar("period_break_running") == 1:
			freeze_match()
		else:
			unfreeze_match()

		if es.ServerVar("sm_match_started") == 1:
			global afk
			afk = {}

			period = es.ServerVar("period")
			if period <= int(es.ServerVar("sm_match_periods")):
				if es.ServerVar("period_running") == 0:
					if es.ServerVar("period_break_running") == 0:
						period_timer(0)

						even = period % 2

						if even == 1:
							team = es.ServerVar("sm_match_name_t")
						else:
							team = es.ServerVar("sm_match_name_ct")

						tokens = {}
						tokens["team"] = team
						lang_msg("kick_off", tokens)
						lang_msg("kick_off", tokens, 1)

			if es.ServerVar("golden_goal") == 1:
				golden_goal_timer(0)

				number = random.randint(0, 1)

				if number == 1:
					team = es.ServerVar("sm_match_name_t")
				else:
					team = es.ServerVar("sm_match_name_ct")

				tokens = {}
				tokens["team"] = team
				lang_msg("kick_off", tokens)
				lang_msg("kick_off", tokens, 1)

# ******************** Functions ********************
def lang_msg(text, tokens, center = 0):
	for player in playerlib.getPlayerList("#human"):
		if center == 0:
			es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))
		else:
			es.centertell(player.userid, messages(text, tokens, player.get("lang")))

def period_timer(time):
	if es.ServerVar("sm_match_started") == 1:
		period = es.ServerVar("period")
		period_length = int(es.ServerVar("sm_match_period_length"))
		time_add = (period - 1) * period_length
		time += time_add

		minutes = int(math.floor(time / 60))
		es.set("sm_match_minutes", minutes)

		seconds = int(time - (minutes * 60))
		es.set("sm_match_seconds", seconds)

		time -= time_add

		score_t = int(es.ServerVar("sm_match_score_t"))
		score_ct = int(es.ServerVar("sm_match_score_ct"))

		display_score_board(minutes, seconds, 1)

		if es.ServerVar("match_paused") == 0:
			if es.ServerVar("sm_match_first_hit") == 0:
				time += 1

		if time <= period_length:
			es.set("period_running", 1)
			es.set("period_break_running", 0)
			gamethread.delayed(1, period_timer, (time))
		else:
			period += 1
			es.set("period", period)

			es.set("period_running", 0)
			es.set("period_break_running", 0)

			if period <= int(es.ServerVar("sm_match_periods")):
				break_length = int(es.ServerVar("sm_match_period_break_length"))
				freeze_match()
				period_break_timer(break_length)

				if es.ServerVar("sm_match_sounds_on") == 1:
					es.cexec_all("playgamesound", es.ServerVar("sm_match_sound_period_end"))
			else:
				if score_t > score_ct:
					es.doblock("soccer_mod_2011/modules/match/end/win_t")
				elif score_t < score_ct:
					es.doblock("soccer_mod_2011/modules/match/end/win_ct")
				elif score_t == score_ct:
					es.doblock("soccer_mod_2011/modules/match/end/draw")

		"""
		if es.ServerVar("match_paused") == 0:
			if es.ServerVar("sm_match_first_hit") == 0:
				for player in playerlib.getPlayerList("#human,#alive"):
					if player.steamid not in afk:
						afk[player.steamid] = {'location': player.getLocation(), 'view': player.viewVector()}
					else:
						if afk[player.steamid]["location"] == player.getLocation() and afk[player.steamid]["view"] == player.viewVector():
							es.msg("#green", player.name + " is afk...")
						afk[player.steamid] = {'location': player.getLocation(), 'view': player.viewVector()}
		"""

def display_score_board(minutes, seconds, type = 1):
	if es.ServerVar("sm_match_score_board_on") == 1:
		if es.exists("keygroup", "sm_keygroup_vote") == 0:
			score_t = int(es.ServerVar("sm_match_score_t"))
			score_ct = int(es.ServerVar("sm_match_score_ct"))

			name_t = es.ServerVar("sm_match_short_name_t")
			name_ct = es.ServerVar("sm_match_short_name_ct")

			if type == 1:
				score_board = ""
			elif type == 2:
				score_board = es.ServerVar("score_board_period") + ": "
			elif type == 3:
				score_board = messages("golden_goal") + ": "

			if es.ServerVar("sm_match_swap_names_on") == 0:
				if seconds < 10:
					message = "%s%s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
				else:
					message = "%s%s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_t, score_t, score_ct, name_ct)
			else:
				if seconds < 10:
					message = "%s%s:0%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)
				else:
					message = "%s%s:%s | %s %s - %s %s" % (score_board, minutes, seconds, name_ct, score_ct, score_t, name_t)

			for ply in playerlib.getPlayerList("#human"):
				es.server.queuecmd('usermsg hudhint %s "%s"' % (ply.userid, message))

			if es.ServerVar("tv_enable") == 1:
				es.menu(1, int(es.getuserid(es.ServerVar("tv_name"))), message)

def freeze_match():
	for ply in playerlib.getPlayerList("#alive"):
		ply.freeze(1)

	es.server.queuecmd("phys_pushscale 1")
	es.server.queuecmd("phys_timescale 0")

def unfreeze_match():
	for ply in playerlib.getPlayerList("#alive"):
		ply.freeze(0)

	es.server.queuecmd("phys_pushscale 900")
	es.server.queuecmd("phys_timescale 1")

def period_break_timer(time):
	if es.ServerVar("sm_match_started") == 1:
		minutes = int(math.floor(time / 60))
		seconds = int(time - (minutes * 60))

		score_t = es.ServerVar("sm_match_score_t")
		score_ct = es.ServerVar("sm_match_score_ct")

		display_score_board(minutes, seconds, 2)

		if es.ServerVar("match_paused") == 0:
			time -= 1

		if time > 0:
			es.set("period_running", 0)
			es.set("period_break_running", 1)
			gamethread.delayed(1, period_break_timer, (time))
		else:
			es.set("period_running", 0)
			es.set("period_break_running", 0)
			es.set("sm_match_first_hit", 1)
			es.server.queuecmd("mp_restartgame 1")

def golden_goal_timer(time):
	if es.ServerVar("sm_match_started") == 1:
		if es.ServerVar("golden_goal") == 1:
			period = es.ServerVar("period")
			period_length = int(es.ServerVar("sm_match_period_length"))
			time_add = (period - 1) * period_length
			time += time_add

			minutes = int(math.floor(time / 60))
			es.set("sm_match_minutes", minutes)

			seconds = int(time - (minutes * 60))
			es.set("sm_match_seconds", seconds)

			time -= time_add

			score_t = es.ServerVar("sm_match_score_t")
			score_ct = es.ServerVar("sm_match_score_ct")

			display_score_board(minutes, seconds, 3)

			if es.ServerVar("match_paused") == 0:
				if es.ServerVar("sm_match_first_hit") == 0:
					time += 1

			gamethread.delayed(1, golden_goal_timer, (time))