﻿import es
import gamethread
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/shout/messages_shout.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/shout/popup_shout.ini")

sounds = ["foul", "goal", "ole", "pass", "save", "shot"]

used = []

# ******************** Load ********************
def load():
	popup = popuplib.create("sm_popup_shout")

	popup.addline(popup_text("title"))

	for i in range(0, len(sounds)):
		popup.addline("%s. %s" % (i + 1, popup_text(sounds[i])))
		popup.select(i + 1, popup_choice)

	popup.addline("0. %s" % (popup_common("close")))

	for i in range(len(sounds) + 1, 10):
		popup.submenu(i, "sm_popup_shout")

# ******************** Commands ********************
def cmd_shout():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.isdead == 0:
			popuplib.send("sm_popup_shout", userid)
		else:
			es.tell(userid, "#green", messages_text("dead", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	player = playerlib.getPlayer(userid)

	if player.isdead == 0:
		if player.steamid not in used:
			used.append(player.steamid)

			es.emitsound("player", userid, es.ServerVar("sm_shout_sound_%s" % (sounds[choice - 1])), "1.0", "1.0")

			gamethread.delayed(es.ServerVar("sm_shout_delay"), used.remove, (player.steamid))
	else:
		es.tell(userid, "#green", messages_text("dead", None, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_shout")