﻿import es
import gamethread
import langlib
import playerlib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/sprint/messages_sprint.ini")

used = []

# ******************** Commands ********************
def cmd_sprint():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.steamid not in used:
			used.append(player.steamid)
			player.setSpeed(es.ServerVar("sm_sprint_speed"))
			es.tell(userid, "#green", messages_text("use", None, player.get("lang")))

			gamethread.delayed(es.ServerVar("sm_sprint_length"), stop, (userid))

			gamethread.delayed(es.ServerVar("sm_sprint_reset"), reset, (userid, player.steamid))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Functions ********************
def stop(userid):
	if es.exists("userid", userid) == 1:
		player = playerlib.getPlayer(userid)
		player.setSpeed(1)
		es.tell(userid, "#green", messages_text("end", None, player.get("lang")))

def reset(userid, steamid):
	used.remove(steamid)

	if es.exists("userid", userid) == 1:
		player = playerlib.getPlayer(userid)
		es.tell(userid, "#green", messages_text("reset", None, player.get("lang")))