﻿import es
import langlib
import playerlib
import popuplib
import repeat

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages = langlib.Strings(lang_dir + "modules/training/messages_training.ini")
texts = langlib.Strings(lang_dir + "modules/training/popup_training.ini")

# ******************** Load ********************
def load():
	es.addons.registerSayFilter(filter)

# ******************** Events ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)
	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "training_randomness":
			set_value(userid, text, "randomness", 0, 1, 500, 5)
			return (0, None, 0)
		elif type == "training_fire_rate":
			set_value(userid, text, "fire_rate", 1, 0.5, 10, 6)
			return (0, None, 0)
		elif type == "training_height":
			set_value(userid, text, "height", 0, 1, 500, 7)
			return (0, None, 0)
		elif type == "training_power":
			set_value(userid, text, "power", 3, 0.001, 10000, 8)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def set_value(userid, text, msg, decimals, min, max, number):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if text != "!cancel":
		error = messages("type_%s" % (msg), tokens, player.get("lang"))
		try:
			if decimals < 1:
				value = int(round(float(text), 0))
			else:
				value = round(float(text), decimals)

			if value >= min:
				if value <= max:
					es.set("sm_training_%s" % (msg), value)

					popuplib.find("sm_popup_admin_training_cannon").modline((number + 2), "->%s. %s: %s" % (number, texts(msg), value))

					if msg == "fire_rate":
						sm_training_cannon = repeat.find("cannon")

						if sm_training_cannon.status() > 1:
							sm_training_cannon.stop()
							es.doblock("soccer_mod_2011/modules/training/cannon/shoot")
							sm_training_cannon.start(float(es.ServerVar("sm_training_fire_rate")), 0)

					tokens["name"] = player.name
					tokens["value"] = value
					lang_msg("set_%s" % (msg), tokens)

					es.keydelete("sm_keygroup_set", player.steamid)
					popuplib.send("sm_popup_admin_training_cannon", userid)
				else:
					es.tell(userid, "#green", error)
			else:
				es.tell(userid, "#green", error)
		except ValueError:
			es.tell(userid, "#green", error)
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send("sm_popup_admin_training_cannon", userid)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(filter)